#include "mapinc.h"

/*      I'm getting the feeling this is another "jam two different bank
        switching hardwares into one mapper".
*/        

/* HES 4-in-1 */
DECLFW(Mapper113_write)
{
        ROM_BANK32((V>>3)&7);
        VROM_BANK8(V&7);
}

      
/*      Deathbots */
DECLFW(Mapper113_writeh)
{
        ROM_BANK32(V&0xF);
}


void Mapper113_init(void)
{
 ROM_BANK32(0);
 SetWriteHandler(0x4020,0x7fff,Mapper113_write);
 SetWriteHandler(0x8000,0xffff,Mapper113_writeh);
}
